org.modeshape.jcr.api

## Interface Workspace

- All Superinterfaces:
    Workspace

      public interface Workspace
      extends Workspace

  An extension of JCR 2.0's `Workspace` interface, with a few ModeShape-specific enhancements.

- - ### Field Summary

    - ### Fields inherited from interface javax.jcr.Workspace

      `NAME_ACTIVITIES_NODE, NAME_CONFIGURATIONS_NODE, NAME_JCR_XMLCHARACTERS, NAME_JCR_XMLTEXT, NAME_NODE_TYPES_NODE, NAME_SYSTEM_NODE, NAME_UNFILED_NODE, NAME_VERSION_STORAGE_NODE, NAME_WORKSPACE_ROOT, PATH_ACTIVITIES_NODE, PATH_CONFIGURATIONS_NODE, PATH_NODE_TYPES_NODE, PATH_SYSTEM_NODE, PATH_UNFILED_NODE, PATH_VERSION_STORAGE_NODE, PATH_WORKSPACE_ROOT, RELPATH_JCR_XMLCHARACTERS`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FederationManager` | `getFederationManager()`
    `NodeTypeManager` | `getNodeTypeManager()` This method returns the ModeShape-specific specialization of the standard `NodeTypeManager` interface.
    `QueryManager` | `getQueryManager()` This method returns the ModeShape-specific specialization of the standard `QueryManager` interface.
    `RepositoryManager` | `getRepositoryManager()` Return a `RepositoryManager` that can be used to administer the Repository instance through which this workspace's session was acquired.
    `void` | `reindex()` Crawl and re-index the content in this workspace.
    `void` | `reindex(String path)` Crawl and index the content starting at the supplied path in this workspace, to the designated depth.
    `Future<Boolean>` | `reindexAsync()` Asynchronously crawl and re-index the content in this workspace.
    `Future<Boolean>` | `reindexAsync(String path)` Asynchronously crawl and index the content starting at the supplied path in this workspace, to the designated depth.

    - ### Methods inherited from interface javax.jcr.Workspace

      `clone, copy, copy, createWorkspace, createWorkspace, deleteWorkspace, getAccessibleWorkspaceNames, getImportContentHandler, getLockManager, getName, getNamespaceRegistry, getObservationManager, getSession, getVersionManager, importXML, move, restore`

- - ### Method Detail

    - #### getNodeTypeManager

          NodeTypeManager getNodeTypeManager()
                                             throws RepositoryException

      This method returns the ModeShape-specific specialization of the standard `NodeTypeManager` interface.

      Specified by:
        `getNodeTypeManager` in interface `Workspace`
      Throws:
        `RepositoryException`

    - #### getQueryManager

          QueryManager getQueryManager()
                                       throws RepositoryException

      This method returns the ModeShape-specific specialization of the standard `QueryManager` interface.

      Specified by:
        `getQueryManager` in interface `Workspace`
      Throws:
        `RepositoryException`

    - #### getRepositoryManager

          RepositoryManager getRepositoryManager()
                                                 throws AccessDeniedException,
                                                        RepositoryException

      Return a `RepositoryManager` that can be used to administer the Repository instance through which this workspace's session was acquired.
      Returns:
        the `RepositoryManager` instance.
      Throws:
        `AccessDeniedException` - if the caller does not have authorization to obtain the manager.
        `RepositoryException` - if another error occurred.
      Since:
        3.0

    - #### reindex

          void reindex()
                       throws RepositoryException

      Crawl and re-index the content in this workspace. This method blocks until the indexing is completed.
      Throws:
        `AccessDeniedException` - if the session does not have the privileges to reindex the workspace
        `RepositoryException` - if there is a problem with this session or workspace
      See Also:
        `reindexAsync()`, `reindexAsync(String)`, `reindex(String)`

    - #### reindex

          void reindex(String path)
                       throws RepositoryException

      Crawl and index the content starting at the supplied path in this workspace, to the designated depth.
      Parameters:
        `path` - the path of the content to be indexed
      Throws:
        `IllegalArgumentException` - if the workspace or path are null, or if the depth is less than 1
        `AccessDeniedException` - if the session does not have the privileges to reindex this part of the workspace
        `RepositoryException` - if there is a problem with this session or workspace
      See Also:
        `reindex()`, `reindexAsync()`, `reindexAsync(String)`

    - #### reindexAsync

          Future<Boolean> reindexAsync()
                                       throws RepositoryException

      Asynchronously crawl and re-index the content in this workspace.
      Returns:
        a future representing the asynchronous operation; never null
      Throws:
        `AccessDeniedException` - if the session does not have the privileges to reindex the workspace
        `RepositoryException` - if there is a problem with this session or workspace
      See Also:
        `reindex()`, `reindex(String)`, `reindexAsync(String)`

    - #### reindexAsync

          Future<Boolean> reindexAsync(String path)
                                       throws RepositoryException

      Asynchronously crawl and index the content starting at the supplied path in this workspace, to the designated depth.
      Parameters:
        `path` - the path of the content to be indexed
      Returns:
        a future representing the asynchronous operation; never null
      Throws:
        `IllegalArgumentException` - if the workspace or path are null, or if the depth is less than 1
        `AccessDeniedException` - if the session does not have the privileges to reindex this part of the workspace
        `RepositoryException` - if there is a problem with this session or workspace
      See Also:
        `reindex()`, `reindex(String)`, `reindexAsync()`

    - #### getFederationManager

          FederationManager getFederationManager()
                                                 throws RepositoryException

      Throws:
        `RepositoryException`

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.